//#############################################################################
// System Tray Application Starter
// Original C Code by 01micko
// Modified by RSH for the use of the LazY DNS - (D)ow(N)load (S)uite
// LazY DNS Wrapper 0.5
//#############################################################################
// to compile: gcc -o example example.c `pkg-config --libs --cflags gtk+-2.0`
//#############################################################################

// Include Files
#include <gtk/gtk.h>
#include <gdk/gdk.h>

// Icons
GdkPixbuf *a_pixbuf;
GtkStatusIcon *tray_icon;

// Error Check on File Open
GError *gerror = NULL;

// File and Filenames
FILE *fp;
char lazyfredname[37]="/usr/local/LazY-FReD/set_preferences";
char lazyreconame[30]="/usr/local/LazY-FReD/LazYReCo";
char lazymaidname[30]="/usr/local/LazY-MAID/LazYMAID";

//#############################################################################
// Left-Click Functions called from Menu
//#############################################################################

// Run LazY FReD
static run_lazy_fred(){
	fp = fopen(lazyfredname,"r");
	if(fp == NULL)
	{
		system("/root/.my-sfs-scripts/LP2_LazY-FReD-1.0.3.sfs.Scripts/LP2_LazY-FReD-1.0.3.sfs.LazY-FReD.run.sh &");
		return 1;
	}
	system("/usr/local/LazY-FReD/set_preferences &");
}

// Run LazY ReCo
static run_lazy_reco(){
	fp = fopen(lazyreconame,"r");
	if(fp == NULL)
	{
		system("/root/.my-sfs-scripts/LP2_LazY-FReD-1.0.3.sfs.Scripts/LP2_LazY-FReD-1.0.3.sfs.LazY-ReCo.run.sh &");
		return 1;
	}
	system("/usr/local/LazY-FReD/LazYReCo &");
}

// Run LazY MAID
static run_lazy_maid(){
	fp = fopen(lazymaidname,"r");
	if(fp == NULL)
	{
		system("/root/.my-sfs-scripts/LP2_LazY-MAID-1.0.3.sfs.Scripts/LP2_LazY-MAID-1.0.3.sfs.LazY-MAID.run.sh &");
		return 1;
	}
	system("/usr/local/LazY-MAID/LazYMAID &");
}

//#############################################################################
// Left-Click-Menu Functions
//#############################################################################

// Menu Entry LazY FReD
void  view_popup_menu_run_lazy_fred (GtkWidget *menuitem, gpointer user_data)
{
    run_lazy_fred();
}
// Menu Entry LazY ReCo
void  view_popup_menu_run_lazy_reco (GtkWidget *menuitem, gpointer user_data)
{
    run_lazy_reco();
}
// Menu Entry LazY MAID
void  view_popup_menu_run_lazy_maid (GtkWidget *menuitem, gpointer user_data)
{
    run_lazy_maid();
}

//#############################################################################
// Right-Click-Menu Functions
//#############################################################################

// Menu Entry Quit
void  view_popup_menu_quit (GtkWidget *menuitem, gpointer user_data)
{
    gtk_main_quit();
}

//#############################################################################
// Menu Function
//#############################################################################

// Right-Click on System Tray Icon
void tray_icon_on_menu_left(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data)
{
	GtkWidget *menu, *menuitem, *label, *iconw, *image, *sep  ;
	menu = gtk_menu_new();
	
	label = gtk_image_menu_item_new_with_label("Beende LazY DNS 0.5 Download Suite");
	image = gtk_image_new_from_file("/usr/local/LazY-DNS/icons/x16-blue.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(label), image);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), label);
	g_signal_connect(label, "activate", (GCallback) view_popup_menu_quit, status_icon);
	
	gtk_widget_show_all(menu);
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, button, gdk_event_get_time(NULL));
}

// Left-Click on System Tray Icon
void tray_icon_on_menu_right(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data)
{
	GtkWidget *menu, *menuitem, *label, *iconw, *image, *sep  ;
	menu = gtk_menu_new();
		
	label = gtk_image_menu_item_new_with_label("LazY FReD Free Repository Downloader");
	image = gtk_image_new_from_file("/usr/local/LazY-DNS/icons/lazydns16.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(label), image);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), label);
	g_signal_connect(label, "activate", (GCallback) view_popup_menu_run_lazy_fred, status_icon);
	
	label = gtk_image_menu_item_new_with_label("LazY ReCo Repository Collector");
	image = gtk_image_new_from_file("/usr/local/LazY-DNS/icons/lazydns16.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(label), image);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), label);
	g_signal_connect(label, "activate", (GCallback) view_popup_menu_run_lazy_reco, status_icon);
	
	label = gtk_image_menu_item_new_with_label("LazY MAID Murga-Linux Attachment-Index Downloader");
	image = gtk_image_new_from_file("/usr/local/LazY-DNS/icons/lazydns16.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(label), image);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), label);
	g_signal_connect(label, "activate", (GCallback) view_popup_menu_run_lazy_maid, status_icon);
	
	gtk_widget_show_all(menu);
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, button, gdk_event_get_time(NULL));
}

//#############################################################################
// System Tray Icon
//#############################################################################

// Create Tray Icon
static GtkStatusIcon *create_tray_icon()
{
	tray_icon = gtk_status_icon_new();
	g_signal_connect(G_OBJECT(tray_icon), "activate", G_CALLBACK(tray_icon_on_menu_right), NULL);
    g_signal_connect(G_OBJECT(tray_icon), "popup-menu", G_CALLBACK(tray_icon_on_menu_left), NULL);
	a_pixbuf=gdk_pixbuf_new_from_file("/usr/local/LazY-DNS/icons/lazydns24.png",&gerror);
	gtk_status_icon_set_from_pixbuf(tray_icon,a_pixbuf);
	gtk_status_icon_set_tooltip(tray_icon, "LazY DNS 0.5 Download Suite");
	gtk_status_icon_set_visible(tray_icon, TRUE);
	return tray_icon;
}

//#############################################################################
// Main Program Functions
//#############################################################################

// Main Program
int main(int argc, char **argv)
{
	gtk_init(&argc, &argv);
	create_tray_icon();
	gtk_main();
	return 0;
}

//#############################################################################
// End of LazY DNS Wrapper
//#############################################################################
